diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/test/attribute-container-test-suite.cc ns-3.32/src/core/test/attribute-container-test-suite.cc
--- ns-3.31/src/core/test/attribute-container-test-suite.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/core/test/attribute-container-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,433 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Caliola Engineering, LLC.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Jared Dulmage <jared.dulmage@caliola.com>
+ */
+
+#include <ns3/test.h>
+#include <ns3/log.h>
+#include <ns3/attribute-container.h>
+#include <ns3/attribute-container-accessor-helper.h>
+#include <ns3/pair.h>
+#include <ns3/double.h>
+#include <ns3/integer.h>
+#include <ns3/string.h>
+#include <ns3/ptr.h>
+#include <ns3/object.h>
+#include <ns3/type-id.h>
+
+#include <list>
+#include <vector>
+#include <map>
+#include <algorithm>
+#include <iterator>
+#include <sstream>
+#include <utility>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("AttributeContainerTestSuite");
+
+class AttributeContainerObject : public Object
+{
+public:
+  AttributeContainerObject ();
+  virtual ~AttributeContainerObject ();
+
+  void ReverseList ();
+
+  static
+  TypeId GetTypeId ();
+
+  friend std::ostream &operator <<(std::ostream &os, const AttributeContainerObject &obj);
+
+private:
+  std::list<double> m_doublelist;
+  std::vector<int> m_intvec;
+  // TODO(jared): need PairValue attributevalue to handle std::pair elements
+  std::map<std::string, int> m_map;
+};
+
+AttributeContainerObject::AttributeContainerObject ()
+{
+
+}
+
+AttributeContainerObject::~AttributeContainerObject ()
+{
+
+}
+
+TypeId
+AttributeContainerObject::GetTypeId ()
+{
+  static TypeId tid = TypeId ("ns3::AttributeContainerObject")
+    .SetParent<Object> ()
+    .SetGroupName("Test")
+    .AddConstructor<AttributeContainerObject> ()
+    .AddAttribute ("DoubleList", "List of doubles",
+                   AttributeContainerValue <DoubleValue> (),
+                   MakeAttributeContainerAccessor <DoubleValue> (&AttributeContainerObject::m_doublelist),
+                   MakeAttributeContainerChecker<DoubleValue> (MakeDoubleChecker<double> ()))
+    .AddAttribute ("IntegerVector", "Vector of integers",
+                   // the container value container differs from the underlying object
+                   AttributeContainerValue <IntegerValue> (),
+                   MakeAttributeContainerAccessor <IntegerValue> (&AttributeContainerObject::m_intvec),
+                   MakeAttributeContainerChecker<IntegerValue> (MakeIntegerChecker<int> ()))
+    .AddAttribute ("MapStringInt", "Map of strings to ints",
+                   // the container value container differs from the underlying object
+                   AttributeContainerValue <PairValue <StringValue, IntegerValue> > (),
+                   MakeAttributeContainerAccessor <PairValue <StringValue, IntegerValue> > (&AttributeContainerObject::m_map),
+                   MakeAttributeContainerChecker<PairValue <StringValue, IntegerValue> > (
+                     MakePairChecker<StringValue, IntegerValue> (MakeStringChecker (), MakeIntegerChecker<int> ())))
+    ;
+  return tid;
+}
+
+void
+AttributeContainerObject::ReverseList ()
+{
+  m_doublelist.reverse ();
+  std::vector<int> tmp;
+  std::copy_backward (m_intvec.begin (), m_intvec.end (), tmp.begin ());
+  m_intvec = tmp;
+}
+
+std::ostream &
+operator << (std::ostream &os, const AttributeContainerObject &obj)
+{
+  os << "AttributeContainerObject: ";
+  bool first = true;
+  for (auto d: obj.m_doublelist)
+    {
+      if (!first) os << ", ";
+      os << d;
+      first = false;
+    }
+  return os;
+}
+
+// this handles mixed constness and compatible, yet
+// distinct numerical classes (like int and long)
+template <class A, class B, class C, class D>
+bool
+operator ==(const std::pair<A, B> &x, const std::pair<C, D> &y)
+{
+  return x.first == y.first && x.second == y.second;
+}
+
+/* Test instantiation, initialization, access */
+class AttributeContainerTestCase : public TestCase
+{
+public:
+  AttributeContainerTestCase ();
+  virtual ~AttributeContainerTestCase () {}
+
+private:
+  virtual void DoRun ();
+};
+
+AttributeContainerTestCase::AttributeContainerTestCase ()
+  : TestCase ("test instantiation, initialization, access")
+{
+
+}
+
+void
+AttributeContainerTestCase::DoRun ()
+{
+ {
+    std::list<double> ref = {1.0, 2.1, 3.145269};
+
+    AttributeContainerValue<DoubleValue> ac (ref);
+
+    NS_TEST_ASSERT_MSG_EQ (ref.size (), ac.GetN (), "Container size mismatch");
+    auto aciter = ac.Begin ();
+    for (auto rend = ref.end (),
+              riter= ref.begin (); riter != rend; ++riter)
+      {
+        NS_TEST_ASSERT_MSG_NE (true, (aciter == ac.End ()), "AC iterator reached end");
+        NS_TEST_ASSERT_MSG_EQ (*riter, (*aciter)->Get (), "Incorrect value");
+        ++aciter;
+      }
+    NS_TEST_ASSERT_MSG_EQ (true, (aciter == ac.End ()), "AC iterator did not reach end");
+  }
+
+  {
+    std::vector<int> ref = {-2, 3, 10, -1042};
+
+    AttributeContainerValue<IntegerValue> ac (ref.begin (), ref.end ());
+
+    NS_TEST_ASSERT_MSG_EQ (ref.size (), ac.GetN (), "Container size mismatch");
+    auto aciter = ac.Begin ();
+    for (auto rend = ref.end (),
+              riter= ref.begin (); riter != rend; ++riter)
+      {
+        NS_TEST_ASSERT_MSG_NE (true, (aciter == ac.End ()), "AC iterator reached end");
+        NS_TEST_ASSERT_MSG_EQ (*riter, (*aciter)->Get (), "Incorrect value");
+        ++aciter;
+      }
+    NS_TEST_ASSERT_MSG_EQ (true, (aciter == ac.End ()), "AC iterator did not reach end");
+  }
+
+  {
+    auto ref = {"one", "two", "three"};
+    AttributeContainerValue<StringValue> ac (ref.begin (), ref.end ());
+
+    NS_TEST_ASSERT_MSG_EQ (3, ac.GetN (), "Container size mismatch");
+    auto aciter = ac.Begin ();
+    for (auto v: ref)
+      {
+        NS_TEST_ASSERT_MSG_NE (true, (aciter == ac.End ()), "AC iterator reached end");
+        NS_TEST_ASSERT_MSG_EQ (v, (*aciter)->Get (), "Incorrect value");
+        ++aciter;
+      }
+    NS_TEST_ASSERT_MSG_EQ (true, (aciter == ac.End ()), "AC iterator did not reach end");
+  }
+
+  {
+    auto ref = {"one", "two", "three"};
+    AttributeContainerValue<StringValue, std::vector> ac (ref);
+
+    NS_TEST_ASSERT_MSG_EQ (3, ac.GetN (), "Container size mismatch");
+    auto aciter = ac.Begin ();
+    for (auto v: ref)
+      {
+        NS_TEST_ASSERT_MSG_NE (true, (aciter == ac.End ()), "AC iterator reached end");
+        NS_TEST_ASSERT_MSG_EQ (v, (*aciter)->Get (), "Incorrect value");
+        ++aciter;
+      }
+    NS_TEST_ASSERT_MSG_EQ (true, (aciter == ac.End ()), "AC iterator did not reach end");
+  }
+
+  {
+    // use int64_t which is default for IntegerValue
+    std::map<std::string, int64_t> ref = { {"one", 1}, {"two", 2}, {"three", 3}};
+    AttributeContainerValue<PairValue <StringValue, IntegerValue> > ac (ref);
+
+    NS_TEST_ASSERT_MSG_EQ (3, ac.GetN (), "Container size mismatch");
+    auto aciter = ac.Begin ();
+    for (auto v: ref)
+      {
+        NS_TEST_ASSERT_MSG_NE (true, (aciter == ac.End ()), "AC iterator reached end");
+        NS_TEST_ASSERT_MSG_EQ (v, (*aciter)->Get (), "Incorrect value");
+        ++aciter;
+      }
+    NS_TEST_ASSERT_MSG_EQ (true, (aciter == ac.End ()), "AC iterator did not reach end");
+
+  }
+}
+
+// test serdes functions
+class AttributeContainerSerializationTestCase : public TestCase
+{
+public:
+  AttributeContainerSerializationTestCase ();
+  virtual ~AttributeContainerSerializationTestCase () {}
+
+private:
+  virtual void DoRun (void);
+};
+
+AttributeContainerSerializationTestCase::AttributeContainerSerializationTestCase ()
+  : TestCase ("test serialization and deserialization")
+{
+
+}
+
+void
+AttributeContainerSerializationTestCase::DoRun (void)
+{
+  {
+    // notice embedded spaces
+    std::string doubles = "1.0001, 20.53, -102.3";
+
+    AttributeContainerValue<DoubleValue> attr;
+    auto checker = MakeAttributeContainerChecker (attr);
+    auto acchecker = DynamicCast<AttributeContainerChecker> (checker);
+    acchecker->SetItemChecker (MakeDoubleChecker<double> ());
+    NS_TEST_ASSERT_MSG_EQ (attr.DeserializeFromString (doubles, checker), true, "Deserialize failed");
+    NS_TEST_ASSERT_MSG_EQ (attr.GetN (), 3, "Incorrect container size");
+
+    std::string reserialized = attr.SerializeToString (checker);
+    std::string canonical = doubles;
+    canonical.erase (std::remove (canonical.begin (), canonical.end (), ' '), canonical.end ());
+    NS_TEST_ASSERT_MSG_EQ (reserialized, canonical, "Reserialization failed");
+  }
+
+  {
+    // notice embedded spaces
+    std::string ints = "1, 2, -3, -4";
+
+    AttributeContainerValue<IntegerValue> attr;
+    auto checker = MakeAttributeContainerChecker (attr);
+    auto acchecker = DynamicCast<AttributeContainerChecker> (checker);
+    acchecker->SetItemChecker (MakeIntegerChecker<int> ());
+    NS_TEST_ASSERT_MSG_EQ (attr.DeserializeFromString (ints, checker), true, "Deserialize failed");
+    NS_TEST_ASSERT_MSG_EQ (attr.GetN (), 4, "Incorrect container size");
+
+    std::string reserialized = attr.SerializeToString (checker);
+    std::string canonical = ints;
+    canonical.erase (std::remove (canonical.begin (), canonical.end (), ' '), canonical.end ());
+    NS_TEST_ASSERT_MSG_EQ (reserialized, canonical, "Reserialization failed");
+  }
+
+  {
+    std::string strings = "this is a sentence with words";
+
+    AttributeContainerValue<StringValue> attr (' ');
+    auto checker = MakeAttributeContainerChecker (attr);
+    auto acchecker = DynamicCast<AttributeContainerChecker> (checker);
+    acchecker->SetItemChecker (MakeStringChecker ());
+    NS_TEST_ASSERT_MSG_EQ (attr.DeserializeFromString (strings, checker), true, "Deserialize failed");
+    NS_TEST_ASSERT_MSG_EQ (attr.GetN (), 6, "Incorrect container size");
+
+    std::string reserialized = attr.SerializeToString (checker);
+    std::string canonical = strings;
+    NS_TEST_ASSERT_MSG_EQ (reserialized, canonical, "Reserialization failed");
+  }
+
+  {
+    std::string pairs = "one 1,two 2,three 3";
+    AttributeContainerValue<PairValue<StringValue, IntegerValue> > attr;
+    auto checker = MakeAttributeContainerChecker (attr);
+    auto acchecker = DynamicCast<AttributeContainerChecker> (checker);
+    acchecker->SetItemChecker (MakePairChecker <StringValue, IntegerValue> (
+                                MakeStringChecker (), MakeIntegerChecker<int> ()));
+    NS_TEST_ASSERT_MSG_EQ (attr.DeserializeFromString (pairs, checker), true, "Deserialization failed");
+    NS_TEST_ASSERT_MSG_EQ (attr.GetN (), 3, "Incorrect container size");
+
+    std::string reserialized = attr.SerializeToString (checker);
+    std::string canonical = pairs;
+    NS_TEST_ASSERT_MSG_EQ (reserialized, canonical, "Reserealization failed");
+
+  }
+}
+
+class AttributeContainerSetGetTestCase : public TestCase
+{
+public:
+  AttributeContainerSetGetTestCase ();
+  virtual ~AttributeContainerSetGetTestCase () {}
+
+private:
+  virtual void DoRun (void);
+};
+
+AttributeContainerSetGetTestCase::AttributeContainerSetGetTestCase ()
+  : TestCase ("test attribute set and get")
+{
+
+}
+
+void
+AttributeContainerSetGetTestCase::DoRun (void)
+{
+  Ptr<AttributeContainerObject> obj = CreateObject<AttributeContainerObject> ();
+  {
+    std::ostringstream oss;
+    oss << *obj;
+    NS_TEST_ASSERT_MSG_EQ (oss.str (), "AttributeContainerObject: ", "DoubleList initialized incorrectly");
+  }
+
+  std::list<double> doubles = {1.1, 2.22, 3.333};
+  obj->SetAttribute ("DoubleList", AttributeContainerValue<DoubleValue> (doubles));
+  {
+    std::ostringstream oss;
+    oss << *obj;
+    NS_TEST_ASSERT_MSG_EQ (oss.str (), "AttributeContainerObject: 1.1, 2.22, 3.333", "DoubleList incorrectly set");
+  }
+
+  obj->ReverseList ();
+  {
+    std::ostringstream oss;
+    oss << *obj;
+    NS_TEST_ASSERT_MSG_EQ (oss.str (), "AttributeContainerObject: 3.333, 2.22, 1.1", "DoubleList incorrectly reversed");
+
+    // NOTE: changing the return container here too!
+    AttributeContainerValue<DoubleValue> value;
+    obj->GetAttribute ("DoubleList", value);
+    NS_TEST_ASSERT_MSG_EQ (doubles.size (), value.GetN (), "AttributeContainerValue wrong size");
+
+    AttributeContainerValue<DoubleValue>::result_type doublevec = value.Get ();
+    NS_TEST_ASSERT_MSG_EQ (doubles.size (), doublevec.size (), "DoublesVec wrong size");
+    auto iter = doubles.rbegin ();
+    for (auto d: doublevec)
+      {
+        NS_TEST_ASSERT_MSG_EQ (d, *iter, "Incorrect value in doublesvec");
+        ++iter;
+      }
+  }
+
+  std::vector<int> ints = {-1, 0, 1, 2, 3};
+  // NOTE: here the underlying attribute container type differs from the actual container
+  obj->SetAttribute ("IntegerVector", AttributeContainerValue<IntegerValue> (ints));
+
+  {
+    // NOTE: changing the container here too!
+    AttributeContainerValue<IntegerValue> value;
+    obj->GetAttribute ("IntegerVector", value);
+    NS_TEST_ASSERT_MSG_EQ (ints.size (), value.GetN (), "AttributeContainerValue wrong size");
+
+    AttributeContainerValue<IntegerValue>::result_type intlist = value.Get ();
+    NS_TEST_ASSERT_MSG_EQ (ints.size (), intlist.size (), "Intvec wrong size");
+    auto iter = ints.begin ();
+    for (auto d: intlist)
+      {
+        NS_TEST_ASSERT_MSG_EQ (d, *iter, "Incorrect value in intvec");
+        ++iter;
+      }
+  }
+
+  std::map<std::string, int> map = { {"one", 1}, {"two", 2}, {"three", 3}};
+  obj->SetAttribute ("MapStringInt", AttributeContainerValue<PairValue <StringValue, IntegerValue> > (map));
+
+  {
+    AttributeContainerValue<PairValue<StringValue, IntegerValue> > value;
+    obj->GetAttribute ("MapStringInt", value);
+    NS_TEST_ASSERT_MSG_EQ (map.size (), value.GetN (), "AttributeContainerValue wrong size");
+
+    // could possibly make custom assignment operator to make assignment statement work
+    std::map<std::string, int> mapstrint;
+    auto lst = value.Get ();
+    for (auto l: lst) mapstrint[l.first] = l.second;
+
+    NS_TEST_ASSERT_MSG_EQ (map.size (), mapstrint.size (), "mapstrint wrong size");
+    auto iter = map.begin ();
+    for (auto v: mapstrint)
+      {
+        NS_TEST_ASSERT_MSG_EQ (v, *iter, "Incorrect value in mapstrint");
+        ++iter;
+      }
+  }
+}
+
+class AttributeContainerTestSuite : public TestSuite
+{
+  public:
+    AttributeContainerTestSuite ();
+};
+
+AttributeContainerTestSuite::AttributeContainerTestSuite ()
+  : TestSuite ("attribute-container-test-suite", UNIT)
+{
+  AddTestCase (new AttributeContainerTestCase (), TestCase::QUICK);
+  AddTestCase (new AttributeContainerSerializationTestCase (), TestCase::QUICK);
+  AddTestCase (new AttributeContainerSetGetTestCase (), TestCase::QUICK);
+}
+
+static AttributeContainerTestSuite AttributeContainerTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/test/attribute-test-suite.cc ns-3.32/src/core/test/attribute-test-suite.cc
--- ns-3.31/src/core/test/attribute-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/test/attribute-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -778,13 +778,13 @@
   ok = p->SetAttributeFailSafe ("TestTimeWithBounds", TimeValue (Seconds (5)));
   NS_TEST_ASSERT_MSG_EQ (ok, true, "Could not SetAttributeFailSafe() via TimeValue to 5s");
 
-  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "+5000000000.0ns", TimeValue (Seconds (5)));
+  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "+5e+09ns", TimeValue (Seconds (5)));
   NS_TEST_ASSERT_MSG_EQ (ok, true, "Attribute not set properly by SetAttributeFailSafe(5s) via TimeValue");
 
   ok = p->SetAttributeFailSafe ("TestTimeWithBounds", StringValue ("3s"));
   NS_TEST_ASSERT_MSG_EQ (ok, true, "Could not SetAttributeFailSafe() via TimeValue to 3s");
 
-  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "+3000000000.0ns", TimeValue (Seconds (3)));
+  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "+3e+09ns", TimeValue (Seconds (3)));
   NS_TEST_ASSERT_MSG_EQ (ok, true, "Attribute not set properly by SetAttributeFailSafe(3s) via StringValue");
 
 
@@ -799,7 +799,7 @@
   ok = p->SetAttributeFailSafe ("TestTimeWithBounds", TimeValue (Seconds (10)));
   NS_TEST_ASSERT_MSG_EQ (ok, true, "Could not SetAttributeFailSafe() via TimeValue to 10s");
 
-  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "+10000000000.0ns", TimeValue (Seconds (10)));
+  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "+1e+10ns", TimeValue (Seconds (10)));
   NS_TEST_ASSERT_MSG_EQ (ok, true, "Attribute not set properly by SetAttributeFailSafe(10s [positive limit]) via StringValue");
 
   //
@@ -808,7 +808,7 @@
   ok = p->SetAttributeFailSafe ("TestTimeWithBounds", TimeValue (Seconds (11)));
   NS_TEST_ASSERT_MSG_EQ (ok, false, "Unexpectedly could SetAttributeFailSafe() via TimeValue to 11s [greater than positive limit]");
 
-  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "+10000000000.0ns", TimeValue (Seconds (10)));
+  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "+1e+10ns", TimeValue (Seconds (10)));
   NS_TEST_ASSERT_MSG_EQ (ok, true, "Error in SetAttributeFailSafe() but value changes");
 
   //
@@ -817,7 +817,7 @@
   ok = p->SetAttributeFailSafe ("TestTimeWithBounds", TimeValue (Seconds (-5)));
   NS_TEST_ASSERT_MSG_EQ (ok, true, "Could not SetAttributeFailSafe() via TimeValue to -5s");
 
-  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "-5000000000.0ns", TimeValue (Seconds (-5)));
+  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "-5e+09ns", TimeValue (Seconds (-5)));
   NS_TEST_ASSERT_MSG_EQ (ok, true, "Attribute not set properly by SetAttributeFailSafe(-5s [negative limit]) via StringValue");
 
   //
@@ -826,7 +826,7 @@
   ok = p->SetAttributeFailSafe ("TestTimeWithBounds", TimeValue (Seconds (-6)));
   NS_TEST_ASSERT_MSG_EQ (ok, false, "Unexpectedly could SetAttributeFailSafe() via TimeValue to -6s");
 
-  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "-5000000000.0ns", TimeValue (Seconds (-5)));
+  ok = CheckGetCodePaths (p, "TestTimeWithBounds", "-5e+09ns", TimeValue (Seconds (-5)));
   NS_TEST_ASSERT_MSG_EQ (ok, true, "Error in SetAttributeFailSafe() but value changes");
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/test/core-example-command-line.reflog ns-3.32/src/core/test/core-example-command-line.reflog
--- ns-3.31/src/core/test/core-example-command-line.reflog	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/test/core-example-command-line.reflog	2020-10-06 15:35:43.000000000 -0700
@@ -1,5 +1,6 @@
 
-command-line-example
+command-line-example:
+
 Initial values:
 intArg:   1
 boolArg:  false
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/test/examples-as-tests-test-suite.cc ns-3.32/src/core/test/examples-as-tests-test-suite.cc
--- ns-3.31/src/core/test/examples-as-tests-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/test/examples-as-tests-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -41,6 +41,50 @@
 namespace ns3 {
 
 namespace tests {
+
+/**
+ * \ingroup examples-as-tests
+ * Run command line example as a test case
+ */
+class CommandLineExampleTestCase : public ExampleAsTestCase
+{
+public:
+  /**
+   * Default constructor
+   */
+  CommandLineExampleTestCase();
+
+  /**
+   * Destructor
+   */
+  virtual ~CommandLineExampleTestCase();
+
+  //Inherited function
+  virtual std::string GetPostProcessingCommand (void) const;
+};
+
+CommandLineExampleTestCase::CommandLineExampleTestCase ()
+    :   ExampleAsTestCase ("core-example-command-line", 
+                           "command-line-example",
+                           NS_TEST_SOURCEDIR)
+{}
+
+CommandLineExampleTestCase::~CommandLineExampleTestCase ()
+{}
+
+/**
+ * Override this function to filter the version string from
+ * the command-line-example output.
+ * Since the version changes each time a commit is made it shouldn't
+ * be tested as part of the command-line-example output
+ */
+std::string
+CommandLineExampleTestCase::GetPostProcessingCommand (void) const
+{
+  //Delete the line that starts with Program Version: 
+  return std::string(R"__(| sed -e "/^Program Version:.*$/d")__");
+}
+
 /**
  * \ingroup examples-as-tests
  * Run examples as tests, checking stdout for regressions.
@@ -59,7 +103,7 @@
 
   AddTestCase (new ExampleAsTestCase ("core-example-sample-random-variable", "sample-random-variable", NS_TEST_SOURCEDIR));
 
-  AddTestCase (new ExampleAsTestCase ("core-example-command-line", "command-line-example", NS_TEST_SOURCEDIR));
+  AddTestCase (new CommandLineExampleTestCase ());
 }
 
 /**
@@ -76,7 +120,7 @@
  * Tests ExampleTestSuite which runs a single example as test suite as specified in constructor arguments.
  */
 
-static ExampleAsTestSuite g_exampleCommandLineTest ("core-example-command-line", "command-line-example", NS_TEST_SOURCEDIR);
+static ExampleAsTestSuite g_exampleCommandLineTest ("core-example-simulator", "sample-simulator", NS_TEST_SOURCEDIR);
 
 }  // namespace tests
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/test/pair-value-test-suite.cc ns-3.32/src/core/test/pair-value-test-suite.cc
--- ns-3.31/src/core/test/pair-value-test-suite.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/core/test/pair-value-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,176 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Caliola Engineering, LLC.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Jared Dulmage <jared.dulmage@caliola.com>
+ */
+
+#include <ns3/test.h>
+#include <ns3/log.h>
+#include <ns3/pair.h>
+#include <ns3/double.h>
+#include <ns3/integer.h>
+#include <ns3/string.h>
+#include <ns3/ptr.h>
+#include <ns3/object.h>
+#include <ns3/type-id.h>
+
+#include <algorithm>
+#include <iterator>
+#include <sstream>
+#include <utility>
+
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("PairTestSuite");
+
+class PairObject : public Object
+{
+public:
+  PairObject ();
+  virtual ~PairObject ();
+
+  static
+  TypeId GetTypeId ();
+
+  friend std::ostream &operator <<(std::ostream &os, const PairObject &obj);
+
+private:
+  std::pair <std::string, std::string> m_stringPair;
+  std::pair <double, int> m_doubleIntPair;
+};
+
+PairObject::PairObject ()
+{
+
+}
+
+PairObject::~PairObject ()
+{
+
+}
+
+TypeId
+PairObject::GetTypeId ()
+{
+  static TypeId tid = TypeId ("ns3::PairObject")
+    .SetParent<Object> ()
+    .SetGroupName("Test")
+    .AddConstructor<PairObject> ()
+    .AddAttribute ("StringPair", "Pair: string, string",
+                   PairValue <StringValue, StringValue> (),
+                   MakePairAccessor <StringValue, StringValue> (&PairObject::m_stringPair),
+                   MakePairChecker<StringValue, StringValue> (MakeStringChecker (), MakeStringChecker ()))
+    .AddAttribute ("DoubleIntPair", "Pair: double int",
+                   // the container value container differs from the underlying object
+                   PairValue <DoubleValue, IntegerValue> (),
+                   MakePairAccessor <DoubleValue, IntegerValue> (&PairObject::m_doubleIntPair),
+                   MakePairChecker<DoubleValue, IntegerValue> (MakeDoubleChecker<double> (), MakeIntegerChecker<int> ()))
+    ;
+  return tid;
+}
+
+std::ostream &
+operator << (std::ostream &os, const PairObject &obj)
+{
+  os << "StringPair = { " << obj.m_stringPair << " } ";
+  os << "DoubleIntPair = { " << obj.m_doubleIntPair << " }";
+  return os;
+}
+
+/* Test instantiation, initialization, access */
+class PairValueTestCase : public TestCase
+{
+public:
+  PairValueTestCase ();
+  virtual ~PairValueTestCase () {}
+
+private:
+  virtual void DoRun ();
+};
+
+PairValueTestCase::PairValueTestCase ()
+  : TestCase ("test instantiation, initialization, access")
+{
+
+}
+
+void
+PairValueTestCase::DoRun ()
+{
+ {
+    std::pair<const int, double> ref = {1, 2.4};
+
+    PairValue<IntegerValue, DoubleValue> ac (ref);
+
+    std::pair<const int, double> rv = ac.Get ();
+    NS_TEST_ASSERT_MSG_EQ (rv, ref, "Attribute value does not equal original");
+  }
+
+  {
+    std::pair<const std::string, double> ref = {"hello", 3.14};
+
+    PairValue<StringValue, DoubleValue> ac;
+    ac.Set (ref);
+    std::pair<const std::string, double> rv = ac.Get ();
+    NS_TEST_ASSERT_MSG_EQ (rv, ref, "Attribute value does not equal original");
+  }
+
+}
+
+class PairValueSettingsTestCase : public TestCase
+{
+public:
+  PairValueSettingsTestCase ();
+
+  void DoRun ();
+};
+
+PairValueSettingsTestCase::PairValueSettingsTestCase ()
+  : TestCase ("test setting through attribute interface")
+{}
+
+void
+PairValueSettingsTestCase::DoRun ()
+{
+  auto p = CreateObject <PairObject> ();
+  p->SetAttribute ("StringPair", PairValue<StringValue, StringValue> (std::make_pair ("hello", "world")));
+  p->SetAttribute ("DoubleIntPair", PairValue<DoubleValue, IntegerValue> (std::make_pair (3.14, 31)));
+
+  std::ostringstream oss;
+  oss << *p;
+  
+  std::ostringstream ref;
+  ref << "StringPair = { (hello,world) } DoubleIntPair = { (3.14,31) }";
+
+  NS_TEST_ASSERT_MSG_EQ ((oss.str ()), (ref.str ()), "Pairs not correctly set");
+}
+
+class PairValueTestSuite : public TestSuite
+{
+  public:
+    PairValueTestSuite ();
+};
+
+PairValueTestSuite::PairValueTestSuite ()
+  : TestSuite ("pair-value-test-suite", UNIT)
+{
+  AddTestCase (new PairValueTestCase (), TestCase::QUICK);
+  AddTestCase (new PairValueSettingsTestCase (), TestCase::QUICK);
+}
+
+static PairValueTestSuite pairValueTestSuite; //!< Static variable for test initialization
